
angular.module('bagu.controllers')
.controller('LoginCtrl', function($scope, $state, $ionicHistory, $ionicSideMenuDelegate, AuthService) {

  // Form data for the login modal
  $scope.loginData = {};

  $scope.loginmessage = '';

  // Perform the login action when the user submits the login form
  $scope.doLogin = function() {
    //console.log('Doing login', $scope.loginData);
    AuthService.login($scope.loginData.username, $scope.loginData.password, $scope.loginData.adminlogin).then(function(authenticated) {
      if($ionicHistory.backView()){
        $ionicHistory.goBackJumpState(['register','login'],function(backview){
          if(!backview){
            $state.go('app.buildings');
          }
        });
      }else{
        $state.go('app.buildings');
        if($ionicSideMenuDelegate.isOpen()){
          $ionicSideMenuDelegate.toggleLeft(false);
        }
      }
    }, function(err) {
      $scope.loginmessage = err.message;
    });
  };

  $scope.$on('$ionicView.enter', function() {
    $scope.loginmessage = '';
  });

});
