angular.module('bagu.controllers')
	//房间
	.controller('RoomCtrl', function ($scope, $state, $stateParams, $ionicModal,
		$http, $ionicPopover, $ionicPopup, $ionicLoading, $ionicHistory, $filter, $ionicListDelegate,
		$Cache, _, $Date,
		$Print, $Rent, $Building, $Room, $RoomValue, $Customer, $Product, $Window, $PriceLog, $Sms, $Invoice,
		DATALIST, LOCAL) {
		/***保存参数***/
		//$scope.roomId = $stateParams.roomId;
		// Form data for the add customer modal
		$scope._customerNew = {};
		//设置默认标题
		$scope.title = '房间';

		/**********自定义方法**********/
		//修改房间状态
		function changeStatus(room) {
			//修正出租状态(如果未设置,则默认改为:1,未出租)
			var roomstatus = !room || !room.roomstatus ? DATALIST.ROOM_STATUS.EMPTY : room.roomstatus;
			//设置标题
			$scope.title = room.code + (DATALIST.ROOM_STATUS.enum[roomstatus
					.toString()] ? '(' + DATALIST.ROOM_STATUS.enum[roomstatus.toString()] +
				')' : '');
			// //设置操作绑定的数据对象
			// $scope.setActionData(room);
			// //设置操作按钮
			// $scope.setActionButtons($scope.getButtons(roomstatus));
			// //设置操作菜单
			// $scope.setActionMenus($scope.getMenus(roomstatus));
		}
		//设置房间
		function setRoom(room) {
			var _room = room;
			//按位拆分房间配置,同时分组
			// var deploysets = [],
			//   _sets = [],
			//   perclass = 4,
			//   i = 0,
			//   deploynames = DATALIST.COMM_DEPLOY;
			// _.forIn(deploynames, function(value, key) { // TODO: 顺序有可能不一致,此处需要改进
			//   var item = {};
			//   item.name = key;
			//   item.value = (_room.deploy && (_room.deploy & Math.pow(2, value)) !==
			//     0);
			//   _sets.push(item);
			//   if (_sets.length > 0 && (_sets.length % perclass === 0 || i ===
			//       deploynames.length - 1)) {
			//     deploysets.push(_sets);
			//     _sets = [];
			//   }
			//   i++;
			// });
			// _room.deploysets = deploysets;
			//设置各分类信息的编辑状态
			_room.editstatus = {};
			_room.editstatus.baseinfo = !(_room.area && _room.area !== 0);
			_room.editstatus.deploy = false;
			_room.editstatus.description = false;
			_room.editstatus.rentsetting = !(_room.price && _room.price !== 0);
			_room.editstatus.contract = false;
			//设置其他属性
			_room.pledgetype = _room.pledge % _room.price === 0 ? _room.pledge /
				_room.price : 0;
			//修改出租状态
			changeStatus(_room);
			//如果为出租状态,则加载并分析产品记录
			if (_room.roomstatus > DATALIST.ROOM_STATUS.ORDER && _room.rent &&
				_room.rent.contract) {
				$Product.fixOrderProducts(_room.rent.contract.products);
			}
			//$scope.title = _room.code;
			//赋值,返回
			$scope.room = _room;
      // //修改房间修改状态
      // $scope.changed = false;
      //监测房间变动
			// $scope.$watchCollection(
			// 	'room',
			// 	function (newValue, oldValue) {
			// 		console.log('room changed!');
      //     $scope.changed = true;
			// 	}
			// );

			//获取楼房信息
			$Building.getBuilding($scope.room.building, false).then(function (building) {
				$scope.building = building;
			});
		}
    //
		// /**********操作定义**********/
		// //roomstatus:{ //出租状态：0,自住; 1,未出租; 2,已预订; 3,已出租; 4,未缴费; 5,快到期; 6,退房中
		// var config = {
		// 	actions: [{
		// 		id: 0,
		// 		text: '对外出租',
		// 		class: '',
		// 		href: undefined,
		// 		click: function (room) {
		// 			$Window.showConfirm('设置为出租房?', '设置为出租房后,系统将帮您进行推广.').then(
		// 				function (ok) {
		// 					if (ok) {
		// 						$Rent.enableRent(room._id).then(function (response) {
		// 							room.roomstatus = DATALIST.ROOM_STATUS.EMPTY;
		// 							setRoom(room);
		// 							$Window.showAlert('恭喜', room.code +
		// 								'已经重新对外出租!');
		// 						});
		// 					}
		// 				});
		// 		}
    //   }, {
		// 		id: 1,
		// 		text: '抄表',
		// 		class: '',
		// 		href: undefined,
		// 		click: function (room) {
		// 			console.log('抄表', room);
		// 			$state.go('app.valuelog', {
		// 				roomId: room._id,
		// 				//productId: ''
		// 			}); //"#/app/valuelog/{{room._id}}/{{product._id}}"
		// 		}
    //   }, {
		// 		id: 2,
		// 		text: '推广',
		// 		class: '',
		// 		href: undefined,
		// 		click: function (room) {
		// 			$Rent.popularize(room._id).then(function (room) {
		// 				console.log('popularize OK');
		// 				setRoom(room);
		// 			});
		// 		}
    //   }, {
		// 		id: 3,
		// 		text: '预订',
		// 		class: '',
		// 		href: undefined,
		// 		click: function (room) {
		// 			console.log('预订', room);
		// 		}
    //   }, {
		// 		id: 4,
		// 		text: '取消预订',
		// 		class: '',
		// 		href: '#/app/buildings',
		// 		click: undefined
    //   }, {
		// 		id: 2,
		// 		text: '出租',
		// 		class: '',
		// 		href: function (room) {
		// 			return '#/app/contract/' + room._id.toString();
		// 		}
    //   }, {
		// 		id: 5,
		// 		text: '退房',
		// 		class: '',
		// 		click: function (room) {
		// 			var buttons = [{
		// 				text: '预约退房'
    //       }, {
		// 				text: '立即退房'
    //       }];
		// 			var buttonFun = function (index) {
		// 				if (index === 0) {
		// 					$scope.preBack();
		// 				} else if (index === 1) {
		// 					$state.go('app.backroom', {
		// 						roomId: room._id
		// 					});
		// 				}
		// 				return true;
		// 			};
		// 			var destructive = '<div style="height:40px;">租客逃租<div>',
		// 				destructiveFun = function () {
		// 					$Window.showConfirm('确认是逃租?', '逃租的租客将会进入系统黑名单,影响租客的信誉度!<br>您确认租客属于逃租吗?').then(function (isok) {
		// 						if (isok) {
		// 							$state.go('app.backroom', {
		// 								roomId: room._id,
		// 								isRunBack: true
		// 							});
		// 						}
		// 					});
		// 					return true;
		// 				};
		// 			$Window.showActionSheet('选择退房方式', buttons, buttonFun, destructive, destructiveFun);
		// 		}
    //   }, {
		// 		id: 6,
		// 		text: '收租',
		// 		class: '',
		// 		// href: function (room) {
		// 		//   return '#/app/rent/' + room._id.toString()+'/';
		// 		// }
		// 		href: undefined,
		// 		click: function (room) {
		// 			//存在最近收费记录,并且未缴费?
		// 			if ($scope.invoice && $scope.invoice.invoicestatus < DATALIST.INVOICE_STATUS.FINANCE) {
		// 				$state.go('app.rent', {
		// 					roomId: room._id,
		// 					invoiceId: $scope.invoice._id
		// 				});
		// 			} else { //新增一期收租记录
		// 				$Window.showConfirm('新增租金单?', '是否新增新一期的租金单?').then(
		// 					function (ok) {
		// 						if (ok) {
		// 							$Rent.newInvoice($scope.building._id, $scope.room._id).then(function (newinvoice) {
		// 								//更新房间最后收租单
		// 								$Invoice.saveRoomLastInvoice2Cache(newinvoice);
		// 								$scope.invoice = newinvoice;
		// 								//更新房间状态为为收费
		// 								$scope.room.roomstatus = DATALIST.ROOM_STATUS.NOFEE;
		// 								$Room.updateRoom2Cache($scope.room);
		// 								//转跳到收租页面
		// 								$state.go('app.rent', {
		// 									roomId: room._id,
		// 									invoiceId: newinvoice._id
		// 								});
		// 							}, function (err) {
		// 								$Window.showAlert('噢噢', '新增收租记录出错!');
		// 							});
		// 						}
		// 					});
		// 			}
		// 		}
    //   }, {
		// 		id: 7,
		// 		text: '费用历史',
		// 		class: '',
		// 		href: function (room) {
		// 			return '#/app/room/' + room._id.toString() + '/invoices';
		// 		}
    //   }, {
		// 		id: 8,
		// 		text: '转让',
		// 		class: '',
		// 		href: undefined,
		// 		click: function (room) {}
    //   }, {
		// 		id: 9,
		// 		text: '续签',
		// 		class: '',
		// 		href: undefined,
		// 		click: function (room) {}
    //   }, {
		// 		id: 10,
		// 		text: '取消退房',
		// 		class: '',
		// 		href: undefined,
		// 		click: function (room) {
		// 			$scope.cancelPreBack();
		// 		}
    //   }, {
		// 		id: 11,
		// 		text: '设为自住',
		// 		class: '',
		// 		href: undefined,
		// 		click: function (room) {
		// 			$Window.showConfirm('设置为自住房?', '设置为自住房后,将不参与出租.').then(
		// 				function (ok) {
		// 					if (ok) {
		// 						$Rent.disableRent(room._id).then(function () {
		// 							room.roomstatus = DATALIST.ROOM_STATUS.OWN;
		// 							setRoom(room);
		// 							$Window.showAlert('恭喜', room.code +
		// 								'已经设置为自住房!');
		// 						});
		// 					}
		// 				});
		// 		}
    //   }, {
		// 		id: 12,
		// 		text: '删除',
		// 		class: '',
		// 		href: undefined,
		// 		click: function (room) {}
    //   }, ],
		// 	statusactions: [{
		// 		status: 0,
		// 		text: '自住',
		// 		buttons: ['对外出租'],
		// 		menus: ['对外出租', '费用历史']
    //   }, {
		// 		status: 1,
		// 		text: '未出租',
		// 		buttons: ['设为自住', '出租'],
		// 		menus: ['设为自住', '出租', '费用历史']
    //   }, {
		// 		status: 2,
		// 		text: '已预订',
		// 		buttons: ['推广', '取消预订', '出租'],
		// 		menus: ['出租', '费用历史']
    //   }, {
		// 		status: 3,
		// 		text: '已出租',
		// 		buttons: ['退房', '收租'],
		// 		menus: ['退房', '收租', '费用历史']
    //   }, {
		// 		status: 4,
		// 		text: '未收费',
		// 		buttons: ['退房', '催缴', '收租'],
		// 		menus: ['退房', '催缴', '收租', '费用历史']
    //   }, {
		// 		status: 5,
		// 		text: '快到期',
		// 		buttons: ['退房', '收租'],
		// 		menus: ['退房', '收租', '费用历史']
    //   }, {
		// 		status: 6,
		// 		text: '退房中',
		// 		buttons: ['推广', '退房', '收租'],
		// 		menus: ['推广', '退房', '收租', '取消退房', '费用历史']
    //   }, ]
		// };
		// //根据状态,计算需要显示的按钮
		// $scope.getButtons = function (status) {
		// 	var result = [];
		// 	var statusconfig = _.find(config.statusactions, {
		// 		'status': status
		// 	});
		// 	if (statusconfig && statusconfig.buttons) {
		// 		_.forEach(statusconfig.buttons, function (button) {
		// 			var action = _.find(config.actions, {
		// 				'text': button
		// 			});
		// 			if (action) {
		// 				result.push(action);
		// 			}
		// 		});
		// 	}
		// 	return result;
		// };
		// //根据状态,计算需要显示的菜单项目
		// $scope.getMenus = function (status) {
		// 	var result = [];
		// 	var statusconfig = _.find(config.statusactions, {
		// 		'status': status
		// 	});
		// 	if (statusconfig && statusconfig.menus) {
		// 		_.forEach(statusconfig.menus, function (item) {
		// 			var action = _.find(config.actions, function (action) {
		// 				return action.text === item;
		// 			});
		// 			if (action) {
		// 				result.push(action);
		// 			}
		// 		});
		// 	}
		// 	return result;
		// };
    //
		// //产品类别项目点击事件
		// $scope.doProductClick = function (product) {
		// 	if ($scope.isAmountProduct(product)) {
		// 		$state.go('app.valuelog', {
		// 			roomId: $scope.room._id,
		// 			productId: product._id
		// 		});
		// 	}
		// };
    //
		// //显示预订信息?
		// $scope.canShowPreOrderInfo = function () {
		// 	return $scope.room && $scope.room.roomstatus === DATALIST.ROOM_STATUS.ORDER && $scope.room.prerent &&
		// 		$scope.room.prerent.preinfo;
		// };
    //
		// //显示合同信息?
		// $scope.canShowContractInfo = function () {
		// 	return $scope.room && $scope.room.roomstatus > DATALIST.ROOM_STATUS.ORDER && $scope.room.rent &&
		// 		$scope.room.rent.contract;
		// };
    //
		// //显示租客信息?
		// $scope.canShowCustomers = function () {
		// 	return $scope.room && $scope.room.roomstatus >= DATALIST.ROOM_STATUS.ORDER && $scope.room.rent &&
		// 		$scope.room.rent.contract;
		// };
    //
		// //显示费用信息?
		// $scope.canShowFeeList = function () {
		// 	return $scope.room && $scope.room.roomstatus >= DATALIST.ROOM_STATUS.ORDER;
		// };
    //
		// //显示产品信息?
		// $scope.canShowProducts = function () {
		// 	return $scope.room && $scope.room.roomstatus >= DATALIST.ROOM_STATUS.RENT && $scope.room.rent &&
		// 		$scope.room.rent.contract;
		// };
    //
		// //增加价格单位的价格信息
		// $scope.getProductPrice = function (product) {
		// 	try {
		// 		var result = product.price.toString();
		// 		switch (product.feetype) {
		// 		case DATALIST.PRODUCT_FEETYPE.ONCE: //一次性收费
		// 			result += '元';
		// 			break;
		// 		case DATALIST.PRODUCT_FEETYPE.MONTHLY: //按月固定
		// 			result += '元/月';
		// 			break;
		// 		case DATALIST.PRODUCT_FEETYPE.AMOUNT: //按量
		// 		case DATALIST.PRODUCT_FEETYPE.STEP: //按量阶梯
		// 			result += '元/' + product.unit;
		// 			break;
		// 		case DATALIST.PRODUCT_FEETYPE.AREA: //按面积
		// 			result += '元/平米/月';
		// 			break;
		// 		case DATALIST.PRODUCT_FEETYPE.PERSON: //人数
		// 			result += '元/人/月';
		// 			break;
		// 		default: //错误的feetype
		// 			break;
		// 		}
		// 		return result;
		// 	} catch (err) {
		// 		return '0元';
		// 	}
		// };
    //
		// //获取按量收费的表底信息
		// $scope.getProductInitValue = function (product) {
		// 	var result = '';
		// 	switch (product.feetype) {
		// 	case DATALIST.PRODUCT_FEETYPE.AMOUNT: //按量
		// 	case DATALIST.PRODUCT_FEETYPE.STEP: //按量阶梯
		// 		result += product.value.toString() + product.unit;
		// 		break;
		// 	default: //错误的feetype
		// 		break;
		// 	}
		// 	return result;
		// };
    //
		// //获得总押金，房租押金，产品费用押金
		// $scope.getPledgeStr = function (contract) {
		// 	var result = '',
		// 		money = 0,
		// 		pledgestr = '';
		// 	if (contract) {
		// 		money = contract.pledge || 0;
		// 		if (contract.products && contract.products.length > 0) {
		// 			_.forEach(contract.products, function (product) {
		// 				if (product.pledge && product.pledge > 0) {
		// 					money += product.pledge;
		// 				}
		// 			});
		// 		}
		// 		result = money.toString() + '元';
		// 	}
		// 	return result;
		// };
		// //获得租客图像
		// $scope.getCustomerPortrait = function (customer) {
		// 	return customer.portrait ? customer.portrait : LOCAL.DEFAULT.CUSTOMER
		// 		.PORTRAIT;
		// };
    //
		// /**********租户管理**********/
		// //删除
		// $scope.deleteCustomer = function (customer) {
		// 	$Window.showConfirm('警告', '确认删除租客' + customer.realname + '?').then(function (ok) {
		// 		if (ok) {
		// 			$Customer.deleteCustomer(customer, $scope.room).then(function () {
		// 				if ($scope.room.rent && $scope.room.rent.contract) {
		// 					_.remove($scope.room.rent.contract.customers, function (item) {
		// 						return item._id === customer._id;
		// 					});
		// 				}
		// 				$Room.deleteCustomer4Cache($scope.room._id, customer);
		// 				$ionicListDelegate.closeOptionButtons();
		// 			});
		// 		}
		// 	});
		// };
    //
		// //打开窗口
		// $scope.addCustomer = function () {
		// 	$scope.CustomerWindow.new($scope.room, {
		// 		onBeforNew: null,
		// 		onAfterNew: $scope.doNewCustomer
		// 	});
		// 	$ionicListDelegate.closeOptionButtons();
		// };
    //
		// //增加租客
		// $scope.doNewCustomer = function (customer) {
		// 	if ($scope.room.rent && $scope.room.rent.contract) {
		// 		// $scope.room.rent.contract.customers.push(customer);
		// 		$Room.addCustomer4Cache($scope.room._id, customer);
		// 	}
		// };
    //
		// //打开窗口
		// $scope.editCustomer = function (customer) {
		// 	$scope.CustomerWindow.edit($scope.room, customer, {
		// 		onBeforEdit: null,
		// 		onAfterEdit: $scope.doEditCustomer
		// 	});
		// 	$ionicListDelegate.closeOptionButtons();
		// };
    //
		// //编辑租客
		// $scope.doEditCustomer = function (customer) {
		// 	//$scope.rentData.customers.push(customer);
		// 	$Room.editCustomer4Cache($scope.room._id, customer);
		// };
    //
		// /**********增加收费项目**********/
    //
		// // 获取收费项目列表,并显示模态窗口
		// $scope.addProduct = function () {
		// 	var orderProducts = [];
		// 	if ($scope.room && $scope.room.rent) {
		// 		orderProducts = $scope.room.rent.contract.products;
		// 	}
		// 	$scope.ProductWindow.select({
		// 		orderProducts: orderProducts,
		// 		onAddProduct: $scope.showAddProductPopup,
		// 		onCancelProduct: $scope.showCancelProductPopup
		// 	});
		// };
    //
		// // 订购产品
		// $scope.doAddProduct = function (productdata, success, error) {
		// 	console.log('Doing addProduct', productdata);
		// 	$Product.addRoomProduct($scope.room, productdata).then(function (newProduct) {
		// 		if ($scope.room && $scope.room.rent && $scope.room.rent.contract) {
		// 			//$scope.room.rent.contract.products.push(newProduct);
		// 			$Room.addProduct4Cache($scope.room._id, newProduct);
		// 		}
		// 		$scope.showAddProductAlert(newProduct, productdata);
		// 		if (success) success(newProduct);
		// 	}, function (err) {
		// 		$scope.errormessage = err.message;
		// 		if (error) error(err);
		// 	});
		// };
    //
		// // 取消订购产品
		// $scope.doCancelProduct = function (productdata, success, error) {
		// 	console.log('Doing cancelProduct', productdata);
		// 	$Product.cancelRoomProduct($scope.room, productdata).then(function () {
		// 		//修改订购记录
		// 		// _.remove($scope.room.rent.contract.products, function (rc) {
		// 		//   return rc.productrecord === productdata.record;
		// 		// });
		// 		$Room.deleteProduct4Cache($scope.room._id, productdata);
		// 		$scope.showCancelProductAlert();
		// 		if (success && _.isFunction(success)) {
		// 			success();
		// 		}
		// 	}, function (err) {
		// 		$Window.showAlert('抱歉', err.message || err);
		// 		if (error && _.isFunction(error)) {
		// 			error();
		// 		}
		// 	});
		// };
    //
		// // 显示添加产品对话框
		// $scope.showAddProductPopup = function (product, success, error) {
		// 	$scope.productdata = {
		// 		product: product._id,
		// 		begintime: new Date(),
		// 		paytype: DATALIST.FINANCE_PAYTYPE.CASH,
		// 		pricestr: '',
		// 		hastimelimit: false,
		// 		haslastvalue: false,
		// 		haspledge: false,
		// 		haspaytype: false,
		// 		paytypes: DATALIST.FINANCE_PAYTYPE.list
		// 	};
		// 	$scope.productdata.endtime = $Product.calcProductEndTime($scope.productdata
		// 		.begintime, product.timelimit);
		// 	$scope.productdata.price = product.price;
		// 	$scope.productdata.lastvalue = 0;
		// 	$scope.productdata.pledge = product.pledge;
    //
		// 	switch (product.feetype) {
		// 	case DATALIST.PRODUCT_FEETYPE.ONCE:
		// 		$scope.productdata.pricestr = '金额';
		// 		$scope.productdata.hastimelimit = true;
		// 		$scope.productdata.haspaytype = true;
		// 		break;
		// 	case DATALIST.PRODUCT_FEETYPE.MONTHLY:
		// 		$scope.productdata.pricestr = '金额(元/月)';
		// 		$scope.productdata.haspledge = true;
		// 		break;
		// 	case DATALIST.PRODUCT_FEETYPE.AMOUNT:
		// 	case DATALIST.PRODUCT_FEETYPE.STEP:
		// 		$scope.productdata.pricestr = '价格(元/' + product.unit + ')';
		// 		$scope.productdata.haslastvalue = true;
		// 		$scope.productdata.haspledge = true;
		// 		break;
		// 	case DATALIST.PRODUCT_FEETYPE.AREA:
		// 		$scope.productdata.pricestr = '价格(元/平方)';
		// 		$scope.productdata.haspledge = true;
		// 		break;
		// 	case DATALIST.PRODUCT_FEETYPE.PERSON:
		// 		$scope.productdata.pricestr = '价格(元/人)';
		// 		$scope.productdata.haspledge = true;
		// 		break;
		// 	}
		// 	var productPopu = $ionicPopup.show({
		// 		//template: template,
		// 		templateUrl: 'templates/popup/order.product.popup.html',
		// 		title: '增加' + (product.name ? product.name : '收费项目'),
		// 		scope: $scope,
		// 		buttons: [{
		// 			text: '取消'
    //     }, {
		// 			text: '<b>确定</b>',
		// 			type: 'button-positive',
		// 			onTap: function (e) {
		// 				return $scope.productdata;
		// 			}
    //     }, ]
		// 	});
    //
		// 	productPopu.then(function (productdata) {
		// 		console.log('Tapped!', productdata);
		// 		productPopu.close();
		// 		if (productdata) {
		// 			$scope.doAddProduct(productdata, function (res) {
		// 				if (success && _.isFunction(success)) {
		// 					success(res);
		// 				}
		// 			}, function (res) {
		// 				if (error && _.isFunction(error)) {
		// 					error();
		// 				}
		// 				product.isordered = false;
		// 			});
		// 		} else {
		// 			product.isordered = false;
		// 		}
		// 	});
		// };
    //
		// // 显示取消产品对话框
		// $scope.showCancelProductPopup = function (product, success, error) {
		// 	$scope.productdata = {
		// 		product: product._id,
		// 		record: product.record,
		// 		begintime: product.begintime,
		// 		endtime: product.endtime,
		// 		backmoney: 0,
		// 		isonceproduct: false
		// 	};
		// 	//一次性收费项目,并且尚未过期
		// 	if (product.feetype === DATALIST.PRODUCT_FEETYPE.ONCE && product.endtime >= new Date()) {
		// 		var mdaydiff1 = $Date.dayDiff(product.begintime, product.endtime);
		// 		var mdaydiff2 = $Date.dayDiff(new Date(), product.endtime);
		// 		$scope.productdata.isonceproduct = true;
		// 		$scope.productdata.lavedays = mdaydiff1.toString() + '天';
		// 		$scope.productdata.backmoney = (Math.round(mdaydiff1 / mdaydiff2) * product.showPrice);
		// 	}
		// 	//有押金的项目
		// 	if (product.feetype !== DATALIST.PRODUCT_FEETYPE.ONCE && product.showPledge > 0) {
		// 		$scope.productdata.ispledgeproduct = true;
		// 		$scope.productdata.backmoney = product.showPledge;
		// 	}
		// 	//如果无需退费则提示确认
		// 	if ($scope.productdata.backmoney === 0) {
		// 		$Window.showConfirm('确认取消?', '取消收费项目前,请确认所有费用均已结算完成!').then(function (ok) {
		// 			if (ok) {
		// 				$scope.doCancelProduct($scope.productdata, function (res) {
		// 					if (success && _.isFunction(success)) {
		// 						success(res);
		// 					}
		// 				}, function (res) {
		// 					if (error && _.isFunction(error)) {
		// 						error();
		// 					}
		// 					product.isordered = true;
		// 				});
		// 			} else {
		// 				product.isordered = true;
		// 			}
		// 		});
		// 	} else { //需要退费
		// 		//弹出对话框
		// 		var productPopu = $ionicPopup.show({
		// 			//template: template,
		// 			templateUrl: 'templates/popup/cancel.product.popup.html',
		// 			title: '取消' + (product.name ? product.name : '收费项目'),
		// 			scope: $scope,
		// 			buttons: [{
		// 				text: '取消'
    //       }, {
		// 				text: '<b>确定</b>',
		// 				type: 'button-positive',
		// 				onTap: function (e) {
		// 					return $scope.productdata;
		// 				}
    //       }, ]
		// 		});
    //
		// 		productPopu.then(function (productdata) {
		// 			console.log('Tapped!', productdata);
		// 			productPopu.close();
		// 			if (productdata) {
		// 				$scope.doCancelProduct(productdata, function (res) {
		// 					if (success && _.isFunction(success)) {
		// 						success(res);
		// 					}
		// 				}, function (res) {
		// 					if (error && _.isFunction(error)) {
		// 						error();
		// 					}
		// 					product.isordered = true;
		// 				});
		// 			} else {
		// 				product.isordered = true;
		// 			}
		// 		});
		// 	}
		// };
    //
		// // 提示
		// $scope.showAddProductAlert = function (product, productdata) {
		// 	var productname = product.name ? product.name : '收费项目';
		// 	var message = '增加' + productname + '成功';
		// 	$Window.showAlert('恭喜', message);
		// };
    //
		// // 提示
		// $scope.showCancelProductAlert = function () {
		// 	$Window.showAlert('恭喜', '取消收费项目成功');
		// };
    //
		// /**********预约退房**********/
		// $scope.preBack = function () {
		// 	//获取最后租金单信息
		// 	$Invoice.getRoomLastInvoice($scope.room.building, $scope.room._id).then(function (invoice) {
		// 		if (invoice && invoice.enddate && invoice.enddate > new Date()) {
		// 			$scope.preBackDay = invoice.enddate;
		// 		} else {
		// 			var rentday = $scope.building && $scope.building.settings ? $scope.building.settings.rentdate : 0;
		// 			$scope.preBackDay = $Date.getRentEndDay(new Date(), rentday);
		// 		}
		// 		var myPopup = $ionicPopup.show({
		// 			template: '<input type="date" ng-model="preBackDay">',
		// 			title: '预计哪一天退房?',
		// 			subTitle: '请选择租客预约退房的日期',
		// 			scope: $scope,
		// 			buttons: [{
		// 				text: '取消'
    //       }, {
		// 				text: '<b>预约退房</b>',
		// 				type: 'button-positive',
		// 				onTap: function (e) {
		// 					return $scope.preBackDay;
		// 				}
    //       }]
		// 		});
    //
		// 		myPopup.then(function (preBackDay) {
		// 			if (preBackDay) {
		// 				$Rent.preBack($scope.building._id, $scope.room._id, {
		// 					backdate: preBackDay
		// 				}).then(function (room) {
		// 					changeStatus($scope.room);
		// 					$Window.showAlert('恭喜', '预约退房成功!<br>同时我们已经开始帮您推广该房间!');
		// 				}, function (err) {
		// 					$Window.showAlert('失败', err.message ? err.message : err.toString());
		// 				});
		// 			}
		// 		});
		// 	});
		// };
    //
		// /**********取消预约退房**********/
		// $scope.cancelPreBack = function () {
		// 	$Rent.cancelPreBack($scope.building._id, $scope.room._id).then(function (room) {
		// 		changeStatus($scope.room);
		// 		$Window.showAlert('恭喜', '取消成功!<br>该房间目前为正常出租状态!');
		// 	}, function (err) {
		// 		$Window.showAlert('失败', err.message ? err.message : err.toString());
		// 	});
		// };

		/**********获取房间数据**********/

		//获取房间
		$scope.getRoom = function (roomId, isRefresh) {
			isRefresh = isRefresh || false;
			$Room.getRoom(roomId, isRefresh).then(function (room) {
					//如果已经出租,且不包含租客详细信息,则在此处完善
					if (room && room.rent && room.rent.contract && _.isArray(room.rent.contract.customers) && room.rent.contract.customers.length > 0) {
						$Customer.getRoomCustomers(room).then(function (customers) {
							_.remove(customers, function (item) {
								return !item || !item._id;
							});
						});
					}
					//获取调租记录
					$PriceLog.getRoomPriceLog(roomId, isRefresh).then(function (
						pricelogs) {
						room.pricelogs = pricelogs;
					}, function (err) {
						room.pricelogs = [];
					});
					//获取最后一期缴费数据
					if (!_.contains([DATALIST.ROOM_STATUS.OWN, DATALIST.ROOM_STATUS.EMPTY, DATALIST.ROOM_STATUS.NULL], room.roomstatus)) {
						$Invoice.getRoomLastInvoice(room.building, roomId, isRefresh).then(function (invoice) {
							if (!invoice) return;
							if (invoice.invoicestatus < DATALIST.INVOICE_STATUS.FINANCE) {
								invoice.statusstr = '未收费';
							} else {
								invoice.statusstr = DATALIST.getEnumStr(DATALIST.INVOICE_STATUS
									.enum, invoice.invoicestatus);
							}
							if (invoice.invoicestatus === DATALIST.INVOICE_STATUS.FINANCE && invoice.financelog) {
								invoice.paytype = DATALIST.getEnumStr(DATALIST.FINANCE_PAYTYPE.enum, invoice.financelog.paytype);
							} else {
								invoice.paytype = '';
							}
							invoice.mobile = invoice.customers && invoice.customers.length > 0 ? invoice.customers[
								0].mobile : '';

							$scope.invoice = invoice;
						});
					}
					//设置房间
					setRoom(room);
				})
				.catch(function (err) {
					console.log('load room error:', err);
				})
				.finally(function () {
					// Stop the ion-refresher from spinning
					if (isRefresh) {
						$scope.$broadcast('scroll.refreshComplete');
					}
				});

		};

		//下拉更新
		$scope.doRefreshRoom = function () {
			$scope.getRoom($stateParams.roomId, true);
		};

		//加载房间数据
		// console.log('Show room', $scope.isAuthenticated(), $stateParams.roomId,
		//   $stateParams.roomCode);
		$scope.getRoom($stateParams.roomId);

		/**********保存修改**********/
		//公用方法
		$scope.doRoomSave = function () {
			//console.log('Doing save room', room);
			$Room.editRoom($scope.room._id, $scope.room).then(function (room) {
				$scope.showSaveAlert();
			}, function (err) {
				$scope.errormessage = (err && err.message) ? err.message :
					'未知错误';
			});
		};

		// An alert dialog
		$scope.showSaveAlert = function () {
			var showProductAlert = $ionicPopup.alert({
				title: '恭喜',
				template: '保存成功!',
				scope: $scope,
			});
			showProductAlert.then(function (res) {
				console.log('保存完成');
			});
		};
    //
		// // 保存基本信息
		// $scope.saveBasicInfo = function () {
		// 	if ($scope.room.editstatus.baseinfo) {
		// 		var editRoom = {
		// 			code: $scope.room.code,
		// 			roomtype: $scope.room.roomtype,
		// 			usage: $scope.room.usage,
		// 			packlevel: $scope.room.packlevel,
		// 			direction: $scope.room.direction,
		// 			floor: $scope.room.floor,
		// 			area: $scope.room.area
		// 		};
		// 		$scope.doRoomSave(editRoom, function () {
		// 			$scope.room.editstatus.baseinfo = !$scope.room.editstatus.baseinfo;
		// 		});
		// 	} else {
		// 		$scope.room.editstatus.baseinfo = !$scope.room.editstatus.baseinfo;
		// 	}
		// };
    //
		// // 保存配置信息
		// $scope.saveDeploy = function () {
		// 	if ($scope.room.editstatus.deploy) {
		// 		// var _sets = [],
		// 		//   _deploy = 0,
		// 		//   _index = 0;
		// 		// for (var i = 0; i < $scope.room.deploysets.length; i++) {
		// 		//   for (var j = 0; j < $scope.room.deploysets[i].length; j++) {
		// 		//     _deploy = _deploy | ($scope.room.deploysets[i][j].value ? Math.pow(
		// 		//       2, _index) : 0);
		// 		//     _index++; //先按位运算,后自增
		// 		//   }
		// 		// }
		// 		// var editRoom = {
		// 		//   deploy: _deploy
		// 		// };
		// 		var editRoom = {
		// 			deploysets: $scope.room.deploysets
		// 		};
    //
		// 		$scope.doRoomSave(editRoom, function () {
		// 			$scope.room.editstatus.deploy = !$scope.room.editstatus.deploy;
		// 		});
		// 	} else {
		// 		$scope.room.editstatus.deploy = !$scope.room.editstatus.deploy;
		// 	}
		// };
    //
		// // 保存配套信息
		// $scope.saveDescription = function () {
		// 	if ($scope.room.editstatus.description) {
		// 		var editRoom = {
		// 			description: $scope.room.description
		// 		};
		// 		$scope.doRoomSave(editRoom, function () {
		// 			$scope.room.editstatus.description = !$scope.room.editstatus.description;
		// 		});
		// 	} else {
		// 		$scope.room.editstatus.description = !$scope.room.editstatus.description;
		// 	}
		// };
    //
		// // 保存出租设置
		// $scope.saveRentSetting = function () {
		// 	if ($scope.room.editstatus.rentsetting) {
		// 		var editRoom = {
		// 			price: $scope.room.price,
		// 			pledge: $scope.room.pledge,
		// 			payment: $scope.room.payment
		// 		};
		// 		$scope.doRoomSave(editRoom, function () {
		// 			$scope.room.editstatus.rentsetting = !$scope.room.editstatus.rentsetting;
		// 		});
		// 	} else {
		// 		$scope.room.editstatus.rentsetting = !$scope.room.editstatus.rentsetting;
		// 	}
		// };
    //
		// // 保存合同信息
		// $scope.saveContract = function () {
		// 	if ($scope.room.editstatus.contract) {
		// 		//数据异常?
		// 		if (!$scope.room || !$scope.room.rent || !$scope.room.rent.contract) {
		// 			$scope.room.editstatus.contract = !$scope.room.editstatus.contract;
		// 			return;
		// 		}
		// 		var contract = $scope.room.rent.contract;
		// 		var cdata = {
		// 			begindate: contract.begindate,
		// 			enddate: contract.enddate,
		// 			price: contract.price,
		// 			pledge: contract.pledge,
		// 			memo: contract.memo
		// 		};
		// 		$Rent.editContract($scope.room._id, cdata).then(function (contract) {
		// 			$scope.room.editstatus.contract = !$scope.room.editstatus.contract;
		// 		});
		// 	} else {
		// 		$scope.room.editstatus.contract = !$scope.room.editstatus.contract;
		// 	}
		// };
    //
		// /**********调租**********/
		// //调租
		// $scope.changeRoomPrice = function () {
		// 	$scope.pricedata = {
		// 		begindate: new Date(),
		// 		price: $scope.room.price
		// 	};
    //
		// 	// An elaborate, custom popup
		// 	var productPopu = $ionicPopup.show({
		// 		template: '\
    //     <label class="item item-input"><span class="input-label">生效日期</span> \
    //       <input class="nopadding" type="date" ng-model="pricedata.begindate"> \
    //     </label> \
    //     <label class="item item-input"><span class="input-label">租金调至</span> \
    //       <input class="nopadding" type="number" ng-model="pricedata.price"> \
    //     </label>',
		// 		title: '调租',
		// 		scope: $scope,
		// 		buttons: [{
		// 			text: '取消'
    //     }, {
		// 			text: '<b>确定</b>',
		// 			type: 'button-positive',
		// 			onTap: function (e) {
		// 				if (!$scope.pricedata.begindate && $scope.pricedata.price >
		// 					0) {
		// 					//除非输入生效日期和正确金额,否则不允许用户关闭对话框
		// 					e.preventDefault();
		// 				} else {
		// 					return $scope.pricedata;
		// 				}
		// 			}
    //     }, ]
		// 	});
    //
		// 	productPopu.then(function (pricedata) {
		// 		console.log('Tapped!', pricedata);
		// 		productPopu.close();
		// 		if (pricedata) {
		// 			console.log('Tapped!', pricedata);
    //
		// 			$PriceLog.addPriceLog($scope.room._id, pricedata).then(
		// 				function (pricelog) {
		// 					//将房屋价格保存到缓存
		// 					if (new Date(pricelog.begindate) <= new Date()) {
		// 						$scope.room.price = pricelog.price;
		// 						$Room.updateRoom2Cache($scope.room);
		// 					}
		// 					//刷新界面
		// 					var cachelog = _.find($scope.room.pricelogs, function (
		// 						item) {
		// 						return item.begindate === pricelog.begindate;
		// 					});
		// 					if (cachelog) {
		// 						if (!$scope.$$phase) {
		// 							$scope.$apply(function () {
		// 								cachelog.price = pricelog.price;
		// 							});
		// 						} else {
		// 							cachelog.price = pricelog.price;
		// 						}
		// 					} else {
		// 						$scope.room.pricelogs.push(pricelog);
		// 						$scope.room.pricelogs = _.sortBy($scope.room.pricelogs,
		// 							function (item) {
		// 								return new Date(item.begindate);
		// 							});
		// 					}
		// 					$Window.showConfirm('调租完成', '是否发送短信通知租客?').then(
		// 						function (ok) {
		// 							if (ok) {
		// 								$Sms.sendChangePriceSms($scope.room, pricelog).then(
		// 									function () {
		// 										$Window.showAlert('恭喜', '调租短信已发送成功!');
		// 									});
		// 							}
		// 						});
		// 				});
		// 		}
		// 	});
		// };
    //
		// //取消调租
		// $scope.deletePriceLog = function (pricelog) {
		// 	$Window.showConfirm('取消调租', '是否取消' + $filter('date')(pricelog.begindate,
		// 		'yy年MM月dd日') + '的调租?').then(function (ok) {
		// 		if (ok) {
		// 			$PriceLog.deletePriceLog(pricelog).then(function () {
		// 				_.remove($scope.room.pricelogs, function (item) {
		// 					return item._id === pricelog._id;
		// 				});
		// 				$Window.showAlert('恭喜', '取消调租成功!');
		// 			});
		// 		}
		// 	});
		// };

		/**********收租(费用)**********/
		// //编辑出租单
		// $scope.doRoomRent = function(invoice) {
		//   $state.go('app.rent', {
		//     roomId: invoice.room,
		//     invoiceId: invoice._id
		//   });
		// };
		//
		// //发送单个催缴短信
		// $scope.doSendSms = function(invoice) {
		//   $Sms.sendInvoiceSms(invoice.building, invoice._id).then(function() {
		//     $Window.showAlert('恭喜', invoice.code + '房催缴短信已发送!');
		//   }, function(err) {
		//     $Window.showAlert('失败', err.message || err);
		//   });
		// };
		// //打印单个租金单
		// $scope.doPrintInvoice = function(invoice) {
		//   //写入租金单数据
		//   $Print.clearPrintData();
		//   $Print.addInvoiceData([invoice]);
		//   $state.go('app.printer');
		// };
		// //设置单个租金单为已收费状态
		// $scope.doSetFee = function(invoice) {
		//   //默认收费方式
		//   $scope.feedata = {
		//     feetype: DATALIST.FINANCE_PAYTYPE.CASH,
		//     financeType: {
		//       0: '现金',
		//       1: '微信',
		//       2: '刷卡',
		//       3: '支付宝',
		//       4: '银行转账'
		//     }
		//   };
		//   $scope.feedata.money = invoice.money;
		//   var myPopup = $ionicPopup.show({
		//     template: ' \
		//       <div class="row"> <div class="col">应收金额:</div><div class="col col-50">{{::feedata.money}}元</div> </div>\
		//       <div class="row"> <div class="col">收费方式:</div> <div class="col"></div></div>\
		//       <div > \
		//         <div class="button-bar"> \
		//           <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 0}" ng-click="feedata.feetype = 0">{{feedata.financeType[0]}}</a> \
		//           <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 1}" ng-click="feedata.feetype = 1">{{feedata.financeType[1]}}</a> \
		//           <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 2}" ng-click="feedata.feetype = 2">{{feedata.financeType[2]}}</a> \
		//         </div> \
		//         <div class="button-bar"> \
		//           <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 3}" ng-click="feedata.feetype = 3">{{feedata.financeType[3]}}</a> \
		//           <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 4}" ng-click="feedata.feetype = 4">{{feedata.financeType[4]}}</a> \
		//         </div> \
		//       </div>',
		//     title: '确认收费',
		//     subTitle: '请仔细核对租金单费用,并选择收费方式',
		//     scope: $scope,
		//     buttons: [{
		//       text: '取消'
		//     }, {
		//       text: '<b>确认</b>',
		//       type: 'button-positive',
		//       onTap: function(e) {
		//         return true;
		//       }
		//     }]
		//   });
		//   myPopup.then(function(res) {
		//     console.log('Tapped!', res);
		//     myPopup.close();
		//     if (res) {
		//       //设置收费状态
		//       $Invoice.updateInvoiceHasFee(invoice, $scope.feedata).then(function(invoice) { //获取楼房未打印的租金单
		//         var buildingId = invoice.building && invoice.building._id ? invoice.building._id : invoice.building;
		//         var roomId = invoice.room && invoice.room._id ? invoice.room._id : invoice.room;
		//         if (buildingId && roomId) {
		//           $RoomValue.updateRoomValue(buildingId, roomId).then(function(roomvalues) {});
		//         }
		//         //$scope.refreshData(false);
		//         changeStatus($scope.room);
		//         $Window.showAlert('恭喜', '收费完成!');
		//         //将该张租金单从列表中删除
		//         _.remove($scope.buildingInvoices, function(item) {
		//           return item._id.toString() === invoice._id.toString();
		//         });
		//       });
		//     }
		//   });
		// };
		//
		// //作废单据
		// $scope.doDeleteInvoice = function(invoice) {
		//   $Window.showConfirm('警告', '是否确认作废该单据?').then(function(isok) {
		//     if (isok) {
		//       $Invoice.deleteInvoice(invoice).then(function(invoice) {
		//         //刷新显示列表
		//         _.remove($scope.buildingInvoices, function(item) {
		//           return item._id === invoice._id;
		//         });
		//         //刷新缓存列表
		//         _.remove($scope.cacheInvoices, function(item) {
		//           return item._id === invoice._id;
		//         });
		//         //刷新按量计费项目的最后抄表记录(表底数)
		//         $RoomValue.updateRoomValue(invoice.building, invoice.room).then(function(roomvalues) {});
		//         //刷新状态
		//         changeStatus($scope.room);
		//         $Window.showAlert('恭喜', '作废单据完成!');
		//       }, function(err) {
		//         $Window.showAlert('失败', err.message || err);
		//       });
		//     }
		//   });
		// };

		/**********事件**********/
		var firstrun = true;
		$scope.$on('$ionicView.enter', function (e) {
			//$Window.showAlert('enter','building');
			if (firstrun) {
				firstrun = false;
			} else {
				//缓存中读取楼房列表
				$scope.getRoom($stateParams.roomId);
			}
		});

	});
