// Ionic config provider
angular.module('bagu')
  //修改默认配置
  .config(function($ionicConfigProvider) {
    $ionicConfigProvider.navBar.alignTitle('center');
    $ionicConfigProvider.backButton.previousTitleText(true);
    // $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
    // $ionicConfigProvider.platform.android.navBar.alignTitle('center');
    // $ionicConfigProvider.platform.ios.backButton.previousTitleText(true).icon('ion-ios-arrow-thin-left');
    // $ionicConfigProvider.platform.android.backButton.previousTitleText(true).icon('ion-android-arrow-back');
    // $ionicConfigProvider.platform.ios.views.transition('ios');
    // $ionicConfigProvider.platform.android.views.transition('android');
    //设置返回按钮文本
    $ionicConfigProvider.backButton.text('返回');
    // //设置客户端类型头部信息
    // $http.defaults.headers.common.Authorization = 'Bearer ' + token;
    // console.log(ionic.Platform.platform(),ionic.Platform.version());
    //原生滚动
    //$ionicConfigProvider.scrolling.jsScrolling(false);
  })
  .run(function($ionicPlatform, $rootScope, $location, $timeout, $ionicHistory, $cordovaToast, SERVER_SETTINGS, _, $Window) {
    $ionicPlatform.ready(function() {
      // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
      // for form inputs)
      // if (window.cordova && window.cordova.plugins.Keyboard) {
      //   window.cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      // }
      if (window.StatusBar) {
        // org.apache.cordova.statusbar required
        window.StatusBar.styleDefault();
      }
      if (screen && screen.lockOrientation) {
        screen.lockOrientation('portrait');
        console.log('lockOrientation');
      }
    });
    //双击退出
    $ionicPlatform.registerBackButtonAction(function(e) {
      console.log($location.path());
      if ($rootScope.backButtonPressedOnceToExit) {
        ionic.Platform.exitApp();
      } else {
        //判断处于哪个页面时双击退出
        if (_.contains(['/login', '/register', '/app/buildings'], $location.path())) {
          $rootScope.backButtonPressedOnceToExit = true;
          $Window.showToast('再按一次退出系统');
          setTimeout(function() {
            $rootScope.backButtonPressedOnceToExit = false;
          }, 2000);
        } else if ($ionicHistory.backView()) {
          $ionicHistory.goBack();
        } else {
          $rootScope.backButtonPressedOnceToExit = true;
          $Window.showToast('再按一次退出系统');
          setTimeout(function() {
            $rootScope.backButtonPressedOnceToExit = false;
          }, 2000);
        }
      }
      e.preventDefault();
      return false;
    }, 100);
  })
  //加载动画设置
  .constant('$ionicLoadingConfig',{
      template : '<ion-spinner icon="bubbles"></ion-spinner>',
      delay:300
  })
  //lodash
  .run(function(_) {
    //do nothing
  })
  //lodash
  .run(function($Mustache, $Date) {
    //do nothing

    //testing
    // var view = {
    //   title: 'Joe',
    //   font: {
    //     size: 100,
    //     name: 'text'
    //   },
    //   calc: function() {
    //     return this.title + this.font.name;
    //   },
    //   items: function() {
    //     return [{
    //       size: 101,
    //       name: '101'
    //     },{
    //       size: 102,
    //       name: '101'
    //     }];
    //   },
    //   today: 'new Date()',
    //   toLocaleDate: function(){
    //     return function (text, render) {
    //       var renderText = render(text);
    //       var newDate = new Date(renderText);
    //       if($Date.isValidDate(newDate)){
    //         return newDate.toLocaleDateString();
    //       }else{
    //         return renderText;
    //       }
    //     };
    //   },
    // };
    // var output = $Mustache.render('{{font.name}} spends {{calc}} {{#items}} {{size}} {{name}} {{/items}} {{today}} {{#toLocaleDate}}{{today}}{{/toLocaleDate}}', view);
    // console.log(output);
  });
