angular.module('bagu.controllers')
  //房间费用历史
  .controller('ProvidersCtrl', function($scope, $stateParams, $ionicPopover, $ionicPopup, $ionicScrollDelegate,
    $http, $Cache, $state, _, DATALIST, $Window, $Print, $Building, $Room, $Product, $RoomValue, $Provider, $Sms) {

    /***参数定义***/
    //url参数
    $scope.productId = $stateParams.productId;
    $scope.roomId = $stateParams.roomId;
    //设置标题
    $scope.title = '第三方服务商';
    //设置标题
    $scope.subTitle = '历史抄表记录';
    //抄表记录
    $scope.valuelogs = [];

    /***工具函数***/

    //刷新数据
    $scope.refreshData = function(fromServer) {
      fromServer = fromServer || false;
      //获取房间信息
      $Provider.getProviders(fromServer).then(function(providers) {
        $scope.providers = providers;
      }).finally(function() {
        if (fromServer) {
          $scope.$broadcast('scroll.refreshComplete');
        }
      });
    };
    //点击服务商,打开服务商产品列表页
    $scope.doProviderClick = function(provider){
      $state.go('app.providerproducts');
    };

    /***初始化数据***/
    //获取楼房未打印的租金单
    $scope.refreshData(false);

    //返回到缓存页面
    var firstrun = true;
    $scope.$on('$ionicView.enter', function(e) {
      //需要刷新列表?
      if (firstrun) {
        firstrun = false;
        return;
      }
      if (!firstrun) {
        $scope.refreshData();
      }
    });
  });
