angular.module('bagu')
	.provider('$Sets', function () {
		return {
			$get: function (_) {

				//配置集合转换为数值
				function value2DeploySets(value, names, perRow) {
					perRow = perRow || 1;
					//按位拆分房间配置,同时分组
					var deploysets = [],
						_sets = [],
						i = 0,
						deploynames = names;
					_.forIn(deploynames, function (itemValue, key) { // TODO: 顺序有可能不一致,此处需要改进
						var item = {};
						item.name = key;
						item.itemValue = itemValue;
						item.value = (value && (value & Math.pow(2, itemValue)) !==
							0);
            if(perRow === 1){
              deploysets.push(item);
            }else{
  						_sets.push(item);
  						if (_sets.length > 0 && (_sets.length % perRow === 0 || i ===
  								deploynames.length - 1)) {
  							deploysets.push(_sets);
  							_sets = [];
  						}
  						i++;
            }
					});
					if(perRow > 1 && _sets && _sets.length > 0){
						var emptyitem = perRow - _sets.length;
						for (var j = 0; j < emptyitem; j++) {
  						_sets.push({});
						}
						deploysets.push(_sets);
					}

					return deploysets;
				}

				//配置集合转换为数值
				function deploySets2Value(sets) {
					var _sets = [],
						_deploy = 0;
					for (var i = 0; i < sets.length; i++) { //行
            //是否还有下级数组(最多两级)
            if(_.isArray(sets[i])){
  						for (var j = 0; j < sets[i].length; j++) { //列
  							_deploy = _deploy | (sets[i][j].value ? Math.pow(
  								2, sets[i][j].itemValue) : 0);
  						}
            }else if(_.isObject(sets[i])){
              _deploy = _deploy | (sets[i].value ? Math.pow(
                2, sets[i].itemValue) : 0);
            }
					}
					return _deploy;
				}

				return {
					value2DeploySets: value2DeploySets,
					deploySets2Value: deploySets2Value
				};
			}
		};
	});
